/**
 *This file is part of stegocurve.

 stegocurve is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 stegocurve is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with stegocurve. If not, see <http://www.gnu.org/licenses/>.
 */

#include "codes/hamming.h"



void init_Hamming_code(Code *C, const uint parameter)
{
  uint
    n = (uint) pow(2, parameter) - 1,
    k = n - parameter;

  init_code_WC(C, n, k, 1);
  update_code_AC(C, n / (double)(n+1));
}


void init_Hamming_codes(Code *C, const uint start, const uint nb)
{
  init_generic_codes(C, start, nb, init_Hamming_code);
}


void Hamming_codes_WC(const char* filename, const uint start, const uint nb)
{
  generic_codes_generic_cases(filename,
			      start,
			      nb,
			      init_Hamming_codes,
			      display_data_WC);
}

void Hamming_codes_AC(const char* filename, const uint start, const uint nb)
{
  generic_codes_generic_cases(filename,
			      start,
			      nb,
			      init_Hamming_codes,
			      display_data_AC);
}
